<?php require_once 'config.php';
/* 
AssetTrackDB Copyright (C) 2013  Tyler Krehbiel (tylerk@gmail.com) 

This file is part of AssetTrackDB. 

AssetTrackDB is free software: you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation, either version 3 of the License, or 
(at your option) any later version. 

AssetTrackDB is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with AssetTrackDB.  If not, see <http://www.gnu.org/licenses/>. 
*/ 

echo "<html>";
echo "<head><title>AssetTrackDB - Site Access</title>";
echo "<link rel='stylesheet' type='text/css' href='mystyle.css' />"; 
echo '<link rel="icon" href="favicon.ico" type="image/x-icon">'; 
echo "</head>"; 
echo "<body>"; 

//--START Menu Code and PULL PHP
include 'includes/menu.php';
include 'includes/pull.php';
include 'includes/lmenu.php';
//--END Menu Code-- 

echo "<center>"; 

//Disallow Read-Only Users Access to this page
if($rostate==1 OR $sadminstate==0)
    { 
        echo "<br><center><div id=err>Read Only / Non-Admin User: You do not have access to this page</div></center>"; 
    }
else {

     if (!empty($_POST['select'])){$id = $_POST["select"];}

  if (!empty($_POST['action'])){
     $action = $_POST['action'];


     
     if (!empty($_POST['username'])){  $username = $_POST['username'];}
     
     if (!empty($_POST['confirm'])){  $confirm = 'yes';} else {$confirm = 'no';}


     if ($action == 'Delete'){
       
       if ($confirm == 'yes'){
          //Check to see if this is the last admin user
          $result1 = mysqli_query($_SESSION["link"], "SELECT sadmin from members WHERE sadmin=1") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));;
          $total_records = mysqli_num_rows($result1);
          $total_records = $total_records - 1;

          $lastadmin = ''; //Init

          if ( $total_records == '0'){
             $result1c = mysqli_query($_SESSION["link"], "SELECT username from members WHERE sadmin=1") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));;
             $rowc = mysqli_fetch_array( $result1c );
             $lastadmin = $rowc['username'];
          }

          if($username ==$lastadmin){
                      echo "<br><div id=dc>".$username." is last admin user, cannot be deleted</div>";

          }


         else {
           mysqli_query($_SESSION["link"], "DELETE FROM members WHERE id='$id'");
           echo "<br>";
           echo "<div id=dc>User ".$username." Deleted!</div><br>";
       }
       
       }
       else{
          echo "<br><center><span id='errb' STYLE='font-weight: bold; font-size: 20px;'>Confirm Delete User:</span> <span id=dc>$username </span></center><br>";

          echo "<form action='siteaccess.php' method='POST' name='main'>";
            echo "<input type='hidden' name='username' value='".$username."'>";
            echo "<input type='hidden' name='action' value='Delete'>";
            echo "<input type='hidden' name='select' value='".$id."'>";
            echo "<input type='hidden' name='confirm' value='yes'>";
            echo "<input type='submit' value='Delete' name='submit' class='fancybuttonR'>";
            echo "</form>";
         
             echo "<br><br><br><br>";
             echo "<br><br><br><br>";
             echo "<br><br><br><br>";
             echo "<br><br><br><br>";

          include 'includes/lfooter.php';
          echo '</center></center>';
          include 'includes/userinfo.php';

          echo "</body>";
          echo "</html>";
          exit;

       }

     }
     elseif ($action == 'Update'){

             //Get Username for Display purposes only


             //1:PASSWORD Update------------------------------------
             $newpass = $_POST['newpass'];

             if ($newpass == ''){
                //DO NOTHING
             }
             else {

             //$salt = mcrypt_create_iv(32, MCRYPT_DEV_URANDOM);
	     $salt = openssl_random_pseudo_bytes(32);
             $salt = base64_encode($salt);
             $passh = $salt . $newpass;

             $password = hash('sha512', $passh );

             //Update Pass and Salt in Database
             mysqli_query($_SESSION["link"], "UPDATE members SET password='$password' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
             mysqli_query($_SESSION["link"], "UPDATE members SET salt='$salt' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));

             echo "<br><div id=dc>".$username."'s Password Updated</div>";
             }
             
             
             //2:TYPE UPDATE------------------------------------
             $type = $_POST["type"];
             if ($type == ''){
                //DO NOTHING
             }
             else{


                  if($type == 'admin'){ //CHANGE TO ADMIN

                           mysqli_query($_SESSION["link"], "UPDATE members SET sadmin='1' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                           mysqli_query($_SESSION["link"], "UPDATE members SET ro='0' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));

                           echo "<br><div id=dc>".$username." Made Admin</div><br>";

                  }
                  elseif($type == 'standard'){ //CHANGE TO standard-------------------------------------------
                            
                            //Check to see if this is the last admin user
                            $result1 = mysqli_query($_SESSION["link"], "SELECT sadmin from members WHERE sadmin=1") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));;
                            $total_records = mysqli_num_rows($result1);
                            $total_records = $total_records - 1;

                            if($total_records < 1){
                            echo "<br><div id=dc>".$username." is last admin user, cannot be made standard</div>";

                            }
                            else {

                                 mysqli_query($_SESSION["link"], "UPDATE members SET sadmin='0' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                                 mysqli_query($_SESSION["link"], "UPDATE members SET ro='0' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                                 echo "<br><div id=dc>".$username." Made Standard</div><br>";
                            }
                  }
                  elseif($type == 'readonly'){ //CHANGE TO read only
                           
                           //Check to see if this is the last admin user
                            $result1 = mysqli_query($_SESSION["link"], "SELECT sadmin from members WHERE sadmin=1") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));;
                            $total_records = mysqli_num_rows($result1);
                            $total_records = $total_records - 1;

                            if($total_records < 1){
                            echo "<br><div id=dc>".$username." is last admin user, cannot be made read only</div>";

                            }
                            else {
                                 mysqli_query($_SESSION["link"], "UPDATE members SET sadmin='0' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                                 mysqli_query($_SESSION["link"], "UPDATE members SET ro='1' WHERE id='$id'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                                 echo "<br><div id=dc>".$username." Made Read Only</div><br>";
                            }
                  }

             }

             if($type == '' AND $newpass == ''){
                 echo "<br><div id=dc>No Changes Selected</div><br>";
             }

     }
     elseif($action == 'add'){

                           if(!empty($_POST["usern"]) AND !empty($_POST["pass1"]) AND !empty($_POST["pass2"])) {
                              $usern = trim($_POST['usern']);
                              $pass1 = $_POST['pass1'];
                              $pass2 = $_POST['pass2'];

                           

                           if($pass1 == $pass2){
                           //echo "<br>Passwords Match<br>";

                           //$salt = mcrypt_create_iv(32, MCRYPT_DEV_URANDOM);
                           $salt = openssl_random_pseudo_bytes(32);
			   $salt = base64_encode($salt);
                           $passh = $salt . $pass1;
     
                           $type = $_POST["type"];
                           
                           $password = hash('sha512', $passh );

                           if ($type =='admin'){
                               $ro = '0';
                               $sa = '1';
                           
                           }
                           elseif($type =='standard'){
                               $ro = '0';
                               $sa = '0';
                           }
                           else{ //READ ONLY
                               $ro = '1';
                               $sa = '0';
                           }

                           //Insert new user
                           mysqli_query($_SESSION["link"], "INSERT INTO members (username, password, ro, createdby, salt, sadmin) VALUES('$usern', '$password', '$ro', '$myusername', '$salt', '$sa') " ) or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                           //Find User ID
                           
                           echo "<br><div id=dc>User: ". $usern ." created as ".ucwords($type)."</div><br>";
                           
                           $result = mysqli_query($_SESSION["link"], "SELECT id FROM members WHERE username='$usern'") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
                           $row = mysqli_fetch_array( $result );
                           $id = $row['id'];
                           //Insert ID into member prefs
                           mysqli_query($_SESSION["link"], "INSERT INTO member_prefs (id, rpp, bar_code, name, serial, age, model, brand, owner, form, use1, co_location, pdate, images, os, co_status, notes, vendor, funding, cost, co_building ) VALUES('$id', '250', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1') " ) or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));

                           }
                           else {
                                 echo "<br><div id=errb>Password Mismatch, user not added!</div>";
                                }
                           }
                           else
                           {
                            echo "<br><div id=err>Username / Password / Password Confirmation cannot be empty</div><br>";
                           };


     }
     

  }






if ($sadminstate == '1'){

echo "<br><center><div STYLE='font-weight: bold; font-size: 20px;'>Add Site User</div></center><br>"; 
echo "<form action='siteaccess.php' method='POST' enctype='multipart/form-data' name='form1'>";
echo "<table style='width: 350px;text-align: left; margin-left: auto; margin-right: auto;' border='0' cellpadding='3' cellspacing='0'>"; 
echo "<tbody>";
echo "<tr>";    
echo "<td style='background-color: #8A98F3; width: 150px;'><p class='add'>Username:</p></td>"; 
echo "<td style='background-color: #8A98F3; width: 200px; text-align: center;'><input name='usern' type='text'></td></tr>"; 
echo "<tr>"; 
echo "<td style=''><p class='add'>Password: </td>"; 
echo "<td style='width: 271px; text-align: center;'><input type='password' name='pass1'></td>"; 
echo "</tr>"; 
echo "<tr>"; 
echo "<td style='background-color: #8A98F3; '><p class='add'>Password: </td>"; 
echo "<td style='background-color: #8A98F3; width: 200px; text-align: center;'><input type='password' name='pass2'></td>";
echo "</tr>"; 
echo "<tr>"; 
echo "<td style=''><p class='add'>Type:";
echo "</td>"; 
echo "<td style='text-align: center;'>";
echo '<select name="type">';
        echo "<option  value='admin'>Admin</option>";
        echo "<option  value='standard'>Standard</option>";
        echo "<option  value='readonly'>Read Only</option>";
echo "</td>";
echo "</td>";
echo "</tr>"; 
echo "</tbody>";
echo "</table>";
echo "<input type='hidden' name='action' value='add'>";
echo "<br><center><input type='submit' value='Submit' name='submit' class='fancybutton'></center>";
echo "</form>"; 

} 

//DELETE SECTION
$result1 = mysqli_query($_SESSION["link"], "SELECT * FROM members ORDER BY username ASC") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
echo "<br><br><h3>Manage Site Users</h3>"; 

$lastadmin = '';   //Init

//TABLE / FOR FOR USER LIST
       
       //Check to see if there is only one admin user
       $result1a = mysqli_query($_SESSION["link"], "SELECT sadmin from members WHERE sadmin=1") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));;
       $total_records = mysqli_num_rows($result1a);
       $total_records = $total_records - 1;
       if ( $total_records == '0'){
          $result1b = mysqli_query($_SESSION["link"], "SELECT username from members WHERE sadmin=1") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));;
          $rowb = mysqli_fetch_array( $result1b );
          $lastadmin = $rowb['username'];
       }


echo "<table class='sortable' style='width:600 ; text-align: left; margin-left: auto; margin-right: auto;' border='0' cellpadding='2' cellspacing='0'>";
echo "<th class=stdc>Name</th><th class=stdc>Type</th><th class=stdc></th><th class=stdc></th><th class=stdc>Created By</th><th class=stdc></th>";
while($row = mysqli_fetch_array( $result1 )) {
           $user = $row['username'];
           echo "<form action='siteaccess.php' method='POST' name='form2'>";
           echo "<tr><td class=bot>";
           echo $user;
           echo "</td>";

           echo "<td class=bot>";
           echo "<input type='hidden' name='select' value='"; echo $row['id']; echo "'>";
           echo "<input type='hidden' name='username' value='"; echo $user; echo "'>";

           echo '<center><select name="type">';
        echo "<option "; if ($row['sadmin'] == '1'){ print "selected value=''>";} else { echo "value='admin'>"; } echo "Admin</option>";
        echo "<option "; if ($row['sadmin'] == '0' AND $row['ro'] == '0') { print "selected value=''>";} else { echo "value='standard'>"; } echo "Standard</option>";
        echo "<option "; if ($row['ro'] == '1') { print "selected value=''>";} else { echo "value='readonly'>"; } echo "Read Only</option>";
        echo "</td>";



        //echo "<td class=bot></td>";echo "<td class=bot></td>";

       echo "<td class=bot><center><input style='width:100px;' type='password' name='newpass' placeholder='New Password'></input></td>"; //<td class=bot><input type='submit' style='width:135px;' value='Update Password' name='action' class='fancybuttonR'></input></td>";
     echo "<td style='width:100px' class=bot><center><input style='width:62px;' type='submit' value='Update' name='action' class='fancybuttonR'></input></td>";

     echo "<td class=bot><center>";
           echo $row['createdby'];
           echo "</td>";

           if($lastadmin == $row['username']){
               //echo "<td style='width:100px' align=right class=bot><input class='fancybuttonG' style='width:52px;' type='submit' value='Delete' name='action' disabled></input></td>";
               echo "<td style='width:100px' align=right class=bot></td>";
           }
           else{
               echo "<td style='width:100px' align=right class=bot><input style='width:52px;' type='submit' value='Delete' name='action' class='fancybuttonR'></input></td>";
           }


     echo "</tr>";
     echo "</form>";
}
echo "</table>";
echo "<br>";


///echo "<center><input type='radio' name='select' value='";
//echo $row['id'];
//echo "'></center>";
//echo "</td><td>";





} 


include 'includes/lfooter.php';
echo '</center></center>'; 
include 'includes/userinfo.php'; 

echo "</body>";
echo "</html>"; 
?>
