<?php require_once 'config.php';
/* 
AssetTrackDB Copyright (C) 2013  Tyler Krehbiel (tylerk@gmail.com) 

This file is part of AssetTrackDB. 

AssetTrackDB is free software: you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. 

AssetTrackDB is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License 
along with AssetTrackDB.  If not, see <http://www.gnu.org/licenses/>.
*/ 


echo "<html>"; 
echo "<head><title>AssetTrackDB - Rooms</title>"; 
echo "<link rel='stylesheet' type='text/css' href='mystyle.css' />"; 
echo '<link rel="icon" href="favicon.ico" type="image/x-icon">'; 
echo "</head>"; 
echo "<body>"; 

//--START Menu Code and PULL PHP
include 'includes/menu.php';
include 'includes/pull.php';
include 'includes/lmenu.php';
//--END Menu Code--

//Disallow Read-Only Users Access to this page 
if($rostate==1) 
    {
    echo "<center><div id=err>Read Only User: You do not have access to this page</div></center>";
    }
else { 


//Query for Buildings and rooms here
$result1b = mysqli_query($_SESSION["link"], "SELECT * FROM building ORDER BY name ASC") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));

//Setup array of buildings and rooms
while( $row = mysqli_fetch_array($result1b,  MYSQLI_ASSOC) ) 
{
    $data[] = array( 
        'name' => $row['name'], 
        'number' => $row['number'] 
    ); 
}

//if no data don't show the page
if (empty($data)) {
    echo '';
    echo '<br><br><center><span id=err style="font-size: 18px;"><a class="special" style="color:red;" href="editbuilding.php">You must setup at least one buiding before you may setup rooms</a></span></center><br><br><br><br><br><br><br><br>';
}
else
{





if (!empty($_POST['multir'])){ 
    $multir= $_POST['multir']; 
    $building = $_POST['building']; 

    $multire = explode(";", $multir); 
    $count = count($multire); 
    $a = '0'; 
     
        while ($a < $count){ 
            $insert = $multire[$a]; 
            $insert = trim($insert); 

        if ($insert == ""){ 
            $a++; 
        } 
        else{ 
            mysqli_query($_SESSION["link"], "INSERT INTO room (roomnumber,building) VALUES('$insert','$building') ") or $mysql_error = 1; 
            $a++; 
        } 
    } 
} 


if(!empty($_POST["action"])) { 
        $action = $_POST["action"]; 
        if(!empty($_POST["select"])){ 
          $select = $_POST["select"]; 
        } 
        else 
        {$select = "";} 
} 
else{ 
  $action = "";} 


if ($action == "Delete"){ 
  $select = $_POST["select"];
   

  $query1d = mysqli_query($_SESSION["link"], "DELETE FROM room WHERE id='$select'");
    echo "<center><br>";
    echo "<table cellpadding=5 border=0><tr><td class=red>";
     
    echo "<span id=dcs>Room Deleted</span>"; 
     
    echo "</td></tr></table>";  
} 
elseif($action == "Update Room") { 

               if($select == "") { 
                     echo "<br><div id=err>Room Number Not Selected</div>"; 
                } 
                elseif(!empty($_POST["up"])){ 
                    $mysql_error = '0'; 
                    $up = trim($_POST["up"]); 
                    $query1a = mysqli_query($_SESSION["link"], "SELECT * FROM room WHERE id='$select'");
                    $row1 = mysqli_fetch_array( $query1a ); 

                     $query1 = mysqli_query($_SESSION["link"], "UPDATE room SET roomnumber='$up' WHERE id='$select'") or $mysql_error = 1; 
                         if($mysql_error == '0'){ 
                                 echo "<br><div id=dcs>Room: "; echo $row1['roomnumber']; echo "<br>Updated to: "; echo $up; echo "</div>"; 
                                 //$query1 = mysql_query("UPDATE tracker SET location='$up' WHERE location='$oldroom' AND WHERE building='$select'") or $mysql_error = 1; 
                                 $query1 = "UPDATE tracker SET location='$up' WHERE location='$row1[roomnumber]' AND building='$row1[building]'"; 
                                 mysqli_query($_SESSION["link"], "$query1"); 
                                              
                             } 
                             else{ 
                                 echo "<br><div id=err>Room: "; echo $row1['roomnumber']; echo "<br>NOT updated, room: "; echo $up; echo " already exists!</div>"; 
                             } 
                 } 
                 else{ 
                     echo "<br><div id=err>No Update Specified</div>"; 
                 } 
} 
elseif($action == "Change Building") { 
    if($select == "") { 
         echo "<br><div id=err>Room Number Not Selected</div>"; 
    } 
      else{ 
          $mysql_error = '0'; 
           $building = $_POST["building"];
           $query1a = mysqli_query($_SESSION["link"], "SELECT roomnumber FROM room WHERE id='$select'");
           $oldroom = mysqli_fetch_array( $query1a ); 
           $query1 = mysqli_query($_SESSION["link"], "UPDATE room SET building='$building' WHERE id='$select'") or $mysql_error = 1;
           $query1b = mysqli_query($_SESSION["link"], "SELECT name FROM building WHERE number='$building'");
           $bldname = mysqli_fetch_array( $query1b ); 
          if ($mysql_error == '0'){ 
           
              echo "<center><br>"; 
              echo "<table border=0 cellpadding=5><tr><td class=red>";

               echo "<center><span id=dcs>Room: </span>"; echo "<span id=dcsb>"; echo $oldroom[0]; echo "</span>"; echo "<br><span id=dcs>Moved to Building: </span>"; echo "<span id=dcsb>";echo $bldname[0]; echo "</span>"; 
                
               echo "</td></tr></table>";  

           } 
           else 
           { 
               echo "<center><br>"; 
               echo "<table border=0 cellpadding=5><tr><td class=red>";
               echo "<br><div id=err>Error: Building : "; echo $bldname[0]; echo " already has a room number: "; echo $oldroom[0]; echo "</div>"; 
               echo "</td></tr></table>";
            
           } 
  } 
} 






$mysql_error = '0'; 

if(!empty($_POST["roomnumber"])){ 

echo "<center><br>"; 
echo "<table border=0 cellpadding=5><tr><td class=red>";

    $room = trim($_POST["roomnumber"]);      //URL BASED METHOD 
    $building = $_POST["building"];      //URL BASED METHOD 

$result1b = mysqli_query($_SESSION["link"], "SELECT name FROM building WHERE number like $building") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
$rowa = mysqli_fetch_array( $result1b ); 
$builda = $rowa['name']; 
     
    mysqli_query($_SESSION["link"], "INSERT INTO room (roomnumber, building) VALUES('$room','$building')") or $mysql_error = 1;
       if ($mysql_error == 1) { 


     
    echo "<div id=err>Error - Room Number: "; echo $room; echo " Already Exsists in "; echo $builda; echo "</div>"; 
    } 
     else { 
     echo "<div id=dcs>Room: "; 
     echo "<span id=dcsb>"; 
     echo $room; 
     echo "</span>"; 
      
     echo "<span=dcs> added to building: </span>"; echo "<span id=dcsb>"; echo $builda; echo "</span><br>"; 
     //echo "<hr width=300 color=red>";
     } 
echo "</td></tr></table>";  
    } 
     
     
    
     

echo "<center><br><table border=0>";
echo "<tr><td>"; 
echo "<center><span style='font-size:20px; font-weight:bold;'>Add Room</span>"; 
echo "</td><td>"; 
echo "<center><span style='font-size:20px; font-weight:bold;'>Add Multiple Rooms</span>"; 
echo "</td></tr>"; 
echo "<tr><td valign='top'>";
echo "<form action='addroom.php' method='post' name='form1'>"; 
echo "<table style='width: 250; text-align: left; margin-left: auto; margin-right: auto;' border='0' cellpadding='2' cellspacing='2'>";
echo "<tbody>";
echo "<tr>";
echo "<td style='text-align: center; background-color: #8A98F3;'><b>Room Number:</b></td>";
echo "<td><input type='text' name='roomnumber' /></td>";
echo "</tr><tr>"; 
echo "<td style='text-align: center; background-color: #8A98F3;'><b>Building:</b></td>";
echo "<td>";
$result1 = mysqli_query($_SESSION["link"], "SELECT * FROM building ORDER BY name ASC") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false))); 
echo "<select name='building'>"; 
while($row = mysqli_fetch_array( $result1 )) { 
echo "<option value='"; 
echo $row['number'];
echo "'>"; echo $row['name'];  echo "</option>"; 
echo "'>"; 
} 
echo "</select>"; 


echo "</td>"; 
echo "</tr></tbody></table><br><br><br>"; 
echo "<center><input type='submit' value='Submit' name='submit' class='fancybuttonM'></center>"; 
echo "</form>"; 

echo "</td><td>"; 

//multiple people section 
echo "<center><div>Seperate with semicolons</div></center>"; 
echo "<form action='addroom.php' method='post' name='form2'>"; 
echo "<table style='width: 250; text-align: left; margin-left: auto; margin-right: auto;' border='0' cellpadding='2' cellspacing='2'>";
echo "<tbody>";
echo "<tr>";
echo "<td style='text-align: center; background-color: #8A98F3;'><b>Room Numbers:</b></td>";
echo "<td><textarea cols='29' rows='5' name='multir'></textarea></td>";
echo "</tr><tr>"; 
echo "<tr>";
echo "<td style='text-align: center; background-color: #8A98F3;'><b>Building:</b></td>"; 
echo "<td>"; 
$result1a = mysqli_query($_SESSION["link"], "SELECT * FROM building ORDER BY name ASC") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
echo "<select name='building'>"; 
while($row1a = mysqli_fetch_array( $result1a )) { 
echo "<option value='"; 
echo $row1a['number']; 
echo "'>"; echo $row1a['name'];  echo "</option>"; 
echo "'>"; 
} 
echo "</select>"; 
echo "</tr></tbody></table><br>";
echo "<center><input type='submit' value='Submit' name='submit' class='fancybuttonM'></input></center>";
echo "</form>"; 
echo "</td></tr><tr>"; 





echo "</td></tr></table>";

//LIST CURRENT PEOPLE: 
$result1 = mysqli_query($_SESSION["link"], "SELECT * FROM room ORDER BY building ASC, roomnumber") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false))); 

echo "<br>"; 



//NEW METHOD START HERE 
//DELETE SECTION
echo "<center><h3>Update / Delete Rooms</h3></center>";
echo "<form action='addroom.php' method='post' name='form2'>";


echo "<table border=0 cellpadding=3 cellspacing=0>";

foreach ($data as $data) { 
     
    echo "<tr><td colspan=14>"; 
    echo "<hr>"; 
    //echo "<br>"; 
    echo "<span id=dcs>"; 
    echo $data['name']; echo ""; //echo $data['number'];
    echo "</span>"; 
    echo "</b>"; 
    echo "</td></tr>";
    $number = $data['number']; 

    $cnt = '0'; 
    $cnt2 = '0'; 
    echo "<tr>"; 
    $result = mysqli_query($_SESSION["link"], "SELECT * FROM room WHERE building = $number ORDER BY roomnumber ASC");
    $num_rows = mysqli_num_rows($result); 

    if($num_rows == '0'){ 
    echo "<td colspan=3>No Rooms</td></tr>"; 
    } 
    else{ 
        while($row = mysqli_fetch_array( $result )) { 
          if($cnt2 == '1'){ 
           echo "<td  bgcolor=#E8EAFC>"; 
       echo "<input type='radio' name='select' value='"; echo $row['id']; echo "'>"; 
       echo "</td>"; 
           echo "<td  bgcolor=#E8EAFC>"; 
           echo $row['roomnumber']; 
           echo "</td>"; 
           $cnt2 = '0'; 
          } 
          else{ 
           echo "<td>"; 
       echo "<input type='radio' name='select' value='"; echo $row['id']; echo "'>"; 
       echo "</td>"; 
           echo "<td>"; 
           echo $row['roomnumber']; 
           echo "</td>"; 
           $cnt2++; 
          } 

        $cnt++; 
          if($cnt == 7) { 
            $cnt = '0'; 
            echo "</tr><tr>"; 
          } 
        } 
        } 
     
     
} 
echo "</table>"; 

echo "<br>"; 

//Buttons for Form 
echo "<table border=0 cellpadding=7><tr><td>";
echo "<input type='textbox' name='up'></input></td><td><input style='width:155px;' type='submit' value='Update Room' name='action' class='fancybuttonR'></input>"; 
echo "</td></tr><tr><td>"; 

$result1b = mysqli_query($_SESSION["link"], "SELECT * FROM building ORDER BY name ASC") or die(((is_object($_SESSION["link"])) ? mysqli_error($_SESSION["link"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)));
echo "<select name='building'>"; 
while($row = mysqli_fetch_array( $result1b )) { 
echo "<option value='"; 
echo $row['number']; 
echo "'>"; echo $row['name'];  echo "</option>"; 
} 

echo "</td><td><input style='width:165px;' type='submit' value='Change Building' name='action' class='fancybuttonR'></input>";
echo "</td></tr><tr><td colspan=2>"; 
echo "<center><input type='submit' value='Delete' name='action' class='fancybuttonR'></input>";
echo "</td></tr></table>";


echo "<center><br></center>"; 
echo "</form>"; 
echo "<br>"; 

} 
}


include 'includes/lfooter.php';
echo '</center></center>'; 
include 'includes/userinfo.php'; 

echo "</body>"; 
echo "</html>"; 
?>